﻿Public Class Form1
    ' True if we should ignore check change events.
    Private IgnoreCheckChangeEvents As Boolean = False

    ' Select or deselect all CheckBoxes.
    Private Sub chkMeals_CheckStateChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkMeals.CheckStateChanged
        If (IgnoreCheckChangeEvents) Then Return

        If (chkMeals.CheckState = CheckState.Indeterminate) Then
            chkMeals.CheckState = CheckState.Unchecked
        End If

        Dim meal_boxes() As CheckBox = {chkBreakfast, chkLunch, chkDinner}
        IgnoreCheckChangeEvents = True
        For Each chk As CheckBox In meal_boxes
            chk.Checked = chkMeals.Checked
        Next chk
        IgnoreCheckChangeEvents = False
    End Sub

    ' The user changed a meal type selection.
    ' Update the chkMeals CheckBox.
    Private Sub chkMealType_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkBreakfast.CheckedChanged, chkLunch.CheckedChanged, chkDinner.CheckedChanged
        If (IgnoreCheckChangeEvents) Then Return

        ' See how many meals are selected.
        Dim num_selected As Integer = 0
        Dim meal_boxes() As CheckBox = {chkBreakfast, chkLunch, chkDinner}
        For Each chk As CheckBox In meal_boxes
            If (chk.Checked) Then num_selected += 1
        Next chk

        ' Set the chkMeals CheckBox appropriately.
        IgnoreCheckChangeEvents = True
        If (num_selected = 3) Then
            chkMeals.CheckState = CheckState.Checked
        ElseIf (num_selected = 0) Then
            chkMeals.CheckState = CheckState.Unchecked
        Else
            chkMeals.CheckState = CheckState.Indeterminate
        End If
        IgnoreCheckChangeEvents = False
    End Sub
End Class
